local auto_manual_mode

script.on_load(function()
	auto_manual_mode = global.auto_manual_mode or {};
end)

script.on_event({"up-event", "down-event", "left-event", "right-event"}, function(e)
	pcall(function()
		local vehicle = game.players[e.player_index].vehicle;

		if vehicle and vehicle.train and game.players[e.player_index].render_mode == defines.render_mode.game then
			if not vehicle.train.manual_mode then
				auto_manual_mode[e.player_index] = vehicle.train.id;
			end
			
			vehicle.train.manual_mode = true;
		end
	end);
end);

script.on_event(defines.events.on_player_driving_changed_state, function(e)
	pcall(function()
		local player = game.players[e.player_index];
		local vehicle = e.entity;

		if player and vehicle and vehicle.train and settings.get_player_settings(player)["auto_manual_mode_restore_when_exit"].value and vehicle.train.id == auto_manual_mode[e.player_index] then
			vehicle.train.manual_mode = false;
		end

		auto_manual_mode[e.player_index] = 0;
	end);
end);
