data:extend({
    {
        type = "item",
        name = "substation",
        icon = "__old-substation__/graphics/icons/substation.png",
        icon_size = 64, icon_mipmaps = 4,
        subgroup = "energy-pipe-distribution",
        order = "a[energy]-d[substation]",
        place_result = "substation",
        stack_size = 50
    },
    {
        type = "electric-pole",
        name = "substation",
        icon = "__old-substation__/graphics/icons/substation.png",
        icon_size = 32,
        flags = {"placeable-neutral", "player-creation"},
        minable = {mining_time = 0.1, result = "substation"},
        max_health = 200,
        corpse = "substation-remnants",
        track_coverage_during_build_by_moving = true,
        resistances =
        {
        {
            type = "fire",
            percent = 90
        }
        },
        collision_box = {{-0.7, -0.7}, {0.7, 0.7}},
        selection_box = {{-1, -1}, {1, 1}},
        drawing_box = {{-1, -3}, {1, 1}},
        maximum_wire_distance = 18,
        supply_area_distance = 9,
        pictures =
        {
        filename = "__old-substation__/graphics/entity/substation/substation.png",
        priority = "high",
        width = 132,
        height = 144,
        direction_count = 4,
        shift = {0.9, -1}
        },
        vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
        working_sound =
        {
        sound = { filename = "__base__/sound/substation.ogg" },
        apparent_volume = 1.5,
        audible_distance_modifier = 0.5,
        probability = 1 / (3 * 60) -- average pause between the sound is 3 seconds
        },
        connection_points =
        {
        {
            shadow =
            {
            copper = {1.9, -0.6},
            green = {1.3, -0.6},
            red = {2.65, -0.6}
            },
            wire =
            {
            copper = {-0.25, -2.71875},
            green = {-0.84375, -2.71875},
            red = {0.34375, -2.71875}
            }
        },
        {
            shadow =
            {
            copper = {1.9, -0.6},
            green = {1.2, -0.8},
            red = {2.5, -0.35}
            },
            wire =
            {
            copper = {-0.21875, -2.71875},
            green = {-0.65625, -3.03125},
            red = {0.1875, -2.4375}
            }
        },
        {
            shadow =
            {
            copper = {1.9, -0.6},
            green = {1.9, -0.9},
            red = {1.9, -0.3}
            },
            wire =
            {
            copper = {-0.21875, -2.71875},
            green = {-0.21875, -3.15625},
            red = {-0.21875, -2.34375}
            }
        },
        {
            shadow =
            {
            copper = {1.8, -0.7},
            green = {1.3, -0.6},
            red = {2.4, -1.15}
            },
            wire =
            {
            copper = {-0.21875, -2.75},
            green = {-0.65625, -2.4375},
            red = {0.1875, -3.03125}
            }
        }
        },
        radius_visualisation_picture =
        {
        filename = "__base__/graphics/entity/small-electric-pole/electric-pole-radius-visualization.png",
        width = 12,
        height = 12,
        priority = "extra-high-no-scale"
        }
    }
})
